#ifndef __VFCHDLIB_H
#define __VFCHDLIB_H

#include <stdint.h>
#include <libvmebus.h>

#define VFCHD_AM_DEFAULT         VME_A32_USER_DATA_SCT
#define VFCHD_DW_DEFAULT         VME_D32
#define VFCHD_SIZEL_DEFAULT      0x80000
#define VFCHD_WRC_OFFSET_DEFAULT 0x40000
#define VFCHD_WRC_MEMORY_DEFAULT 0x00000
#define VFCHD_WRC_SYSCON_DEFAULT 0x20400
#define VFCHD_WRC_VUART_DEFAULT  0x20500

/* VFCHD CSR offsets */
#define FUN0ADER	0x7FF60
#define FUN1ADER	0x7FF70
#define INT_LEVEL	0x7ff58
#define INTVECTOR	0x7ff5c
#define WB_32_64	0x7ff30
#define BIT_SET_REG	0x7FFF8
#define BIT_CLR_REG	0x7FFF4
#define WB32		1
#define RESET_CORE	0x80
#define ENABLE_CORE	0x10

struct vfchd_dev {
	uint32_t           wrc_base_offset;
	uint32_t           wrc_mem_base;
	uint32_t           wrc_syscon_base;
	uint32_t           wrc_vuart_base;
	uint8_t            slot;
	struct vme_mapping map;
};

uint32_t vfchd_wrc_readl(struct vfchd_dev *, uint32_t);

void vfchd_wrc_writel(struct vfchd_dev *, uint32_t, uint32_t);

void vfchd_wrc_disable(struct vfchd_dev *);

void vfchd_wrc_enable(struct vfchd_dev *);

void vfchd_close(struct vfchd_dev *);

struct vfchd_dev *vfchd_open(int, char **);


#endif //__VFCHDLIB_H
